include:
  # see here for details: https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Terraform/Base.latest.gitlab-ci.yml
  - template: Terraform/Base.latest.gitlab-ci.yml

stages:
  - init
  - validate
  - build
  - deploy

.development:
  variables:
    TF_ROOT: ${CI_PROJECT_DIR}/env/development
    TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/development

.production:
  variables:
    TF_ROOT: ${CI_PROJECT_DIR}/env/production
    TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/production

init_development:
  extends:
    - .init
    - .development
  needs: []

validate_development:
  extends:
    - .validate
    - .development
  needs:
    - job: init_development

build_development:
  extends:
    - .build
    - .development
  needs:
    - job: validate_development

deploy_development:
  extends:
    - .deploy
    - .development
  dependencies:
    - build_development
  environment: development
  needs:
    - job: build_development

init_production:
  extends:
    - .init
    - .production
  needs: []

validate_production:
  extends:
    - .validate
    - .production
  needs:
    - job: init_production

build_production:
  extends:
    - .build
    - .production
  needs:
    - job: validate_production

deploy_production:
  extends:
    - .deploy
    - .production
  dependencies:
    - build_production
  environment: production
  needs:
    - job: build_production
